/* this file is included in ccm.C only, its not a usual .h file */
#ifndef _GlobalVariables_h
#define _GlobalVariables_h 1

#include "Externals.h"   // define structures (Joerg Sep05)

struct prm Params;        // CCM parameter
struct ctrl Control;      // program Control Parameters
struct UC UnitCell;       // defines the unit cell completely
struct sub sublatticeMagnetisation;  // defines the subLattice
struct neighbours LatticeNeighbours;
double BravaisLattice[3][3];  // JS0903: old: struct bravais a[4],b[4],c[4]
double inversBravaisLattice[3][3];
struct symmetries LatticeSymmetries;

// JS 0903: dynamic allocation, usefull on large clusters of small nodes
struct spinConfigs *spinConfigurations=NULL;        // [MAX_NUM_CONFIGURATIONS];
struct spinConfigs *excitedSpinConfigurations=NULL; // [MAX_NUM_CONFIGURATIONS];
int         NumberConfigurations=0;
int         NumberExcitedConfigurations=0;

// struct hamiltonian_defn Hamiltonian_types[MAX_BONDS+1][MAX_TERMS13+1];
// struct hamiltonian_defn Hamiltonian      [MAX_BONDS+1][MAX_TERMS62+1];
struct hamiltonian_defn Hamiltonian[MAX_BONDS+1][13+1];

// struct hamiltonian_defn expectation_types[MAX_EXPECTATIONS+1][MAX_TERMS13+1];
// struct hamiltonian_defn expectation      [MAX_EXPECTATIONS+1][MAX_TERMS62+1];
struct hamiltonian_defn expectation[MAX_EXPECTATIONS+1][13+1];

// Other global variables.

int  max_number_cells_BT;
int sizeLUT=0;                // size of lookUpTable
int (*lookUpTable)[3]=NULL;   // idx to {x,y,z}
int  *BTarray;                // {x,y,z} to idx (bounding triangle)

int    totalPoints;

/* collect */
// projection/mapping of 62 terms to 13 input terms
// using this is simpler as using the old term62[13][num[13]] method
//  ToDo: rename term_13 to map62[62+1]
// map13: /* 1 */ zz z+ z- +z -z +- -+ ++ -- /* 10 */ z - z^2 + 
const int map62[62+1]={   /* element 0 is not used */
  0, /* 1 */ 1,1,1,1,1, /* 6 */ 2,2, /* 8 */ 3,3,3,3,3,3, /* 14 */ 4,4,
  /* 16 */ 5,5,5,5,5,5, /* 22 */ 6,6, 7,7, 8,
  /* 27 */ 9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,
  /* 46 */ 3,3,3, /* 49 */ 5,5,5, /* 52 */ 6, 7,
  /* 54 */ 10, 11,11,11, /* 58 */ 12,12,12,12, /* 62 */ 13};

// mapping of 81 excitation terms to 13 output terms
const int map81[81+1]={  /* element 0 is not used */
  0, /* 1 */ 1,1,1,1,1, /* 6 */ 2,
  /* 7 */ 3,3,3,3,3,3,3,3,3,3,3,3,3, /* 20 */ 4,
  /* 21 */ 5,5,5,5,5,5,5,5,5,5,5,5,5, /* 34 */ 6,6,6, /* 37 */ 7,7,7,
  /* 40 */ 9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,
  /* 74 */ 10, /* 75 */ 11,11,11, /* 78 */ 12,12,12,12 };
      

/* obtain */

int binary_max[31];
int trimary_max[MAX_LSUBM+1];

// file pointers.

// char terms_fname[80]; /* term file fileName */
// int  terms_shm_fd=-1; /* term file descriptor, if SHM used */
// FILE *terms_fp=NULL;  /* term file */
// FILE *fp_gs;          /* gs-terms */
FILE *fp1;            /* input.ccm */
FILE *fp2;            /* output.results */
// FILE *fp_exp;            /* expectation.results */ obsolete! Jun08
FILE *fp_exc;            /* excitation.results */
/*
 * - linux has no problems by using all free memory as IO cache
 *   and give it back on demand, so we dont need lot of extra buffer
 * - solaris has a buffer cache of fixed size, this is bad and
 *   can cause excessiv disk access where there is enough free memory 
 *   or dont give back memory when other jobs need it
 * - so the user can choose full buffering to reduce disk access to 0
 *  
 */
char *fp_buf=NULL;    /* read/write buffer may be bigger than the file */

// solve variables.

double maximum;
double minimum;
double increment;

// restriction on choice of clusters.

int restrictionClusters;

// direction bonds or not?

int directional;

// solution strategy

int solutionStrategy;

// parallel variables

int myid;
int npe;
#endif
